package br.usp.ime.blog.actions;

import java.math.BigDecimal;

import br.usp.ime.blog.dominio.Post;
import br.usp.ime.blog.repositorios.FabricaDeRepositorios;
import br.usp.ime.blog.repositorios.RepositorioDePosts;

public class AvaliarAC extends BaseBlogAC {

	@Override
	public String executa() throws Exception {

		int idDoPost = Integer.parseInt(request.getParameter("id"));
		int nota = Integer.parseInt(request.getParameter("nota"));

		RepositorioDePosts repositorioDePosts = FabricaDeRepositorios
				.fabricaRepositorioDePosts();
		Post post = repositorioDePosts.pegaPost(idDoPost);
		post.avaliaEm(nota);

		repositorioDePosts.atualizaPost(post);
		
		StringBuilder jsonBuilder = new StringBuilder();
		jsonBuilder.append("{");
		jsonBuilder.append("\"qtd\":\""+post.getAvaliacao().getQuantidadeNotas()+"\",\n");
		jsonBuilder.append("\"media\":\""+arredonda(post.getAvaliacao().getMediaNotas())+"\"");
		jsonBuilder.append("}");
		
		response.setContentType("text/x-json");
		response.getWriter().println(jsonBuilder.toString());

		return "";
	}
	
	private double arredonda(double valor) {
		BigDecimal bd = new BigDecimal( Double.toString(valor) );
		bd = bd.setScale( 2, BigDecimal.ROUND_HALF_UP );
		return bd.doubleValue();		
	}

}
