package br.usp.ime.blog.actions;

import java.util.List;

import br.usp.ime.blog.dominio.Blog;
import br.usp.ime.blog.dominio.BlogRecomendado;
import br.usp.ime.blog.dominio.Pagina;
import br.usp.ime.blog.dominio.Post;
import br.usp.ime.blog.repositorios.Blogroll;
import br.usp.ime.blog.repositorios.FabricaDeRepositorios;
import br.usp.ime.blog.repositorios.RepositorioDeConfiguracoes;
import br.usp.ime.blog.repositorios.RepositorioDePaginas;
import br.usp.ime.blog.repositorios.RepositorioDePosts;
import br.usp.ime.blog.repositorios.RepositorioException;
import br.usp.ime.blog.servicos.ranking.Ranking;
import br.usp.ime.blog.servicos.ranking.RankingDosMelhores;
import br.usp.ime.blog.servicos.ranking.RankingDosPiores;
import br.usp.ime.controller.ApplicationController;

public abstract class BaseBlogAC extends ApplicationController {

	protected void carregaLadoDireito() throws RepositorioException {

		RepositorioDeConfiguracoes repositorioDeConfigs = FabricaDeRepositorios
				.fabricaRepositorioDeConfiguracoes();
		Blog blog = repositorioDeConfigs.pegaBlog();
		request.setAttribute("blog", blog);

		RepositorioDePaginas repositorioDePaginas = FabricaDeRepositorios
				.fabricaRepositorioDePaginas();
		List<Pagina> paginas = repositorioDePaginas.listaPaginas();
		request.setAttribute("paginas", paginas);

		RepositorioDePosts repositorioDePosts = FabricaDeRepositorios
				.fabricaRepositorioDePosts();
		List<Post> todosPosts = repositorioDePosts.listaPostsPublicados();

		Ranking rankingDosMelhores = new RankingDosMelhores();
		List<Post> melhores = rankingDosMelhores.rankeia(todosPosts);
		request.setAttribute("melhores", melhores);

		Ranking rankingDosPiores = new RankingDosPiores();
		List<Post> piores = rankingDosPiores.rankeia(todosPosts);
		request.setAttribute("piores", piores);

		Blogroll blogroll = FabricaDeRepositorios.fabricaBlogroll();
		List<BlogRecomendado> blogsRecomendados = blogroll.listaBlogs();
		request.setAttribute("blogroll", blogsRecomendados);
	}

}
