package br.usp.ime.blog.actions;

import java.util.Date;

import br.usp.ime.blog.dominio.Comentario;
import br.usp.ime.blog.dominio.Post;
import br.usp.ime.blog.repositorios.FabricaDeRepositorios;
import br.usp.ime.blog.repositorios.RepositorioDePosts;
import br.usp.ime.blog.repositorios.RepositorioException;
import br.usp.ime.controller.ApplicationController;

public class ComentarAC extends ApplicationController {

	@Override
	public String executa() throws Exception {
		int idDoPost = Integer.parseInt(request.getParameter("id"));
		postaComentario(idDoPost);

		return "Post.usp?id=" + idDoPost;
	}

	private void postaComentario(int idDoPost) throws RepositorioException {
		Comentario comentario = pegaComentarioDoUsuario();

		RepositorioDePosts repositorioDePosts = FabricaDeRepositorios
				.fabricaRepositorioDePosts();
		Post postAtual = repositorioDePosts.pegaPost(idDoPost);
		postAtual.adicionaComentario(comentario);
	}

	private Comentario pegaComentarioDoUsuario() {
		Comentario c = new Comentario();

		c.setData(new Date());
		c.setAutor(request.getParameter("autor"));
		c.setConteudo(request.getParameter("conteudo"));
		c.setEmail(request.getParameter("email"));

		return c;
	}

}
