package br.usp.ime.blog.actions.admin;

import br.usp.ime.blog.dominio.Post;
import br.usp.ime.blog.repositorios.FabricaDeRepositorios;
import br.usp.ime.blog.repositorios.RepositorioDePosts;
import br.usp.ime.blog.repositorios.RepositorioException;
import br.usp.ime.controller.ApplicationController;

public class AtualizarPostAC extends ApplicationController {

	@Override
	public String executa() throws Exception {
		atualizaPost();
		return "AdministrarPosts.usp";
	}

	private void atualizaPost() throws RepositorioException {
		Post post = (Post) request.getSession().getAttribute("post");
		populaPost(post);
		RepositorioDePosts repositorioDePosts = FabricaDeRepositorios
				.fabricaRepositorioDePosts();
		repositorioDePosts.atualizaPost(post);
		request.getSession().removeAttribute("post");
	}

	private void populaPost(Post post) {
		post.setTitulo(request.getParameter("titulo"));
		post.setConteudo(request.getParameter("conteudo"));
		post.setPublicado(estaPublicado());
	}

	private boolean estaPublicado() {
		return request.getParameter("publicado") != null;
	}
}
