package br.usp.ime.blog.actions.admin;

import java.util.Calendar;

import br.usp.ime.blog.dominio.Blogueiro;
import br.usp.ime.blog.dominio.Post;
import br.usp.ime.blog.repositorios.FabricaDeRepositorios;
import br.usp.ime.blog.repositorios.RepositorioDePosts;
import br.usp.ime.blog.repositorios.RepositorioException;
import br.usp.ime.controller.ApplicationController;

public class SalvarPostAC extends ApplicationController {

	@Override
	public String executa() throws Exception {
		salvaPost();
		return "AdministrarPosts.usp";
	}

	private void salvaPost() throws RepositorioException {
		Post post = pegaNovoPost();
		RepositorioDePosts repositorioDePosts = FabricaDeRepositorios
				.fabricaRepositorioDePosts();
		repositorioDePosts.adicionaPost(post);
	}

	private Post pegaNovoPost() {
		Post post = new Post();
		Blogueiro blogueiro = (Blogueiro) request.getSession().getAttribute("blogueiro");
		
		post.setTitulo(request.getParameter("titulo"));
		post.setConteudo(request.getParameter("conteudo"));
		post.setData(Calendar.getInstance());
		post.setPublicado(estaPublicado());
		post.setBlogueiro(blogueiro);

		return post;
	}

	private boolean estaPublicado() {
		return request.getParameter("publicado") != null;
	}
}
