package br.usp.ime.blog.dominio;

import java.util.Calendar;
import java.util.List;

import org.apache.commons.lang.StringUtils;

import br.usp.ime.blog.repositorios.FabricaDeRepositorios;
import br.usp.ime.blog.repositorios.RepositorioDePosts;
import br.usp.ime.blog.repositorios.RepositorioException;

public class Post {
	private int id;
	private String titulo;
	private String conteudo;
	private Calendar data;
	private boolean publicado;
	private Blogueiro blogueiro;
	private List<Comentario> comentarios;
	private Avaliacao avaliacao;

	public void setId(int id) {
		this.id = id;
	}

	public int getId() {
		return id;
	}

	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}

	public String getTitulo() {
		return titulo;
	}

	public void setConteudo(String conteudo) {
		this.conteudo = conteudo;
	}

	public String getConteudo() {
		return conteudo;
	}

	public void setData(Calendar data) {
		this.data = data;
	}

	public Calendar getData() {
		return data;
	}

	public void setPublicado(boolean publicado) {
		this.publicado = publicado;
	}

	public boolean isPublicado() {
		return publicado;
	}

	public void setBlogueiro(Blogueiro blogueiro) {
		this.blogueiro = blogueiro;
	}

	public Blogueiro getBlogueiro() {
		return blogueiro;
	}

	public String getResumo() {
		return StringUtils.substring(getConteudo(), 0, 200);
	}

	public void setComentarios(List<Comentario> comentarios) {
		this.comentarios = comentarios;
	}

	public List<Comentario> getComentarios() {
		return comentarios;
	}

	public void setAvaliacao(Avaliacao avaliacao) {
		this.avaliacao = avaliacao;
	}

	public Avaliacao getAvaliacao() {
		return avaliacao;
	}

	public int getQtdeComentarios() {
		return comentarios.size();
	}

	public void adicionaComentario(Comentario c) throws RepositorioException {
		getComentarios().add(c);

		RepositorioDePosts repositorioDePost = FabricaDeRepositorios
				.fabricaRepositorioDePosts();
		repositorioDePost.adicionaComentario(this, c);
	}

	public void avaliaEm(int nota) {
		if (getAvaliacao().getQuantidadeNotas() == 0)
			getAvaliacao().setMediaNotas(nota);
		else
			getAvaliacao().setMediaNotas(
					(getAvaliacao().getMediaNotas()*getAvaliacao().getQuantidadeNotas() + (double) nota) / (getAvaliacao().getQuantidadeNotas()+1));

		getAvaliacao().setQuantidadeNotas(
				getAvaliacao().getQuantidadeNotas() + 1);
	}

}
