package br.usp.ime.blog.filtros;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

public class FiltroDeAutenticacao implements Filter {

	private FilterConfig filterConfig;

	public void init(FilterConfig filterConfig) throws ServletException {
		this.filterConfig = filterConfig;
	}

	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain filterChain) throws IOException, ServletException {
		System.out.println("+++++++++++++++++++++++++++++");
		if (usuarioAutenticado(request) || usuarioAutenticando(request)) {
			filterChain.doFilter(request, response);
		} else {
			RequestDispatcher rd = filterConfig.getServletContext()
					.getRequestDispatcher("/admin/Login.usp");
			rd.forward(request, response);
		}
	}

	public void destroy() {
		filterConfig = null;
	}

	private boolean usuarioAutenticando(ServletRequest request) {
		String uri = ((HttpServletRequest) request).getRequestURI();
		return uri.endsWith("Login.usp") || uri.endsWith("Autenticar.usp");
	}
	
	private boolean usuarioAutenticado(ServletRequest request) {
		return ((HttpServletRequest) request).getSession().getAttribute(
				"blogueiro") != null;
	}
}
