package br.usp.ime.blog.repositorios;

import br.usp.ime.blog.repositorios.impl.jdbc.BlogrollJdbc;
import br.usp.ime.blog.repositorios.impl.jdbc.RepositorioDeBlogueirosJdbc;
import br.usp.ime.blog.repositorios.impl.jdbc.RepositorioDeConfiguracoesJdbc;
import br.usp.ime.blog.repositorios.impl.jdbc.RepositorioDePaginasJdbc;
import br.usp.ime.blog.repositorios.impl.jdbc.RepositorioDePostsJdbc;

public class FabricaDeRepositorios {

	public static RepositorioDePaginas fabricaRepositorioDePaginas() {
		return new RepositorioDePaginasJdbc();
	}

	public static RepositorioDePosts fabricaRepositorioDePosts() {
		return new RepositorioDePostsJdbc();
	}

	public static RepositorioDeConfiguracoes fabricaRepositorioDeConfiguracoes() {
		return new RepositorioDeConfiguracoesJdbc();
	}

	public static Blogroll fabricaBlogroll() {
		return new BlogrollJdbc();
	}

	public static RepositorioDeBlogueiros fabricaRepositorioDeBlogueiros() {
		return new RepositorioDeBlogueirosJdbc();
	}
}
