package br.usp.ime.blog.repositorios.impl.jdbc;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import br.usp.ime.blog.repositorios.RepositorioException;

public abstract class BaseRepositorioJdbc {

	private Connection con = null;
	private static final String DRIVER = "org.gjt.mm.mysql.Driver";
	private static final String URL = "jdbc:mysql://localhost/blog";
	private static final String USUARIO = "root";
	private static final String SENHA = "root";

	protected void conecta() throws RepositorioException {
		try {
			Class.forName(DRIVER);
			con = DriverManager.getConnection(URL, USUARIO, SENHA);
		} catch (ClassNotFoundException e) {
			throw new RepositorioException(e);
		} catch (SQLException e) {
			throw new RepositorioException(e);
		}
	}

	protected void finaliza() {
		try {
			if (con != null) {
				con.close();
				con = null;
			}
		} catch (SQLException ignorada) {
		}
	}

	protected ResultSet executaQuery(String sql) throws RepositorioException {
		Statement stmt;

		if (con == null)
			conecta();

		try {
			stmt = con.createStatement();
			return stmt.executeQuery(sql);
		} catch (SQLException e) {
			throw new RepositorioException(e);
		}
	}

	protected PreparedStatement preparaQuery(String sql)
			throws RepositorioException {

		if (con == null)
			conecta();

		try {
			return con.prepareStatement(sql);
		} catch (SQLException e) {
			throw new RepositorioException(e);
		}
	}
}
