package br.usp.ime.blog.repositorios.impl.jdbc;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import br.usp.ime.blog.dominio.Blogueiro;
import br.usp.ime.blog.repositorios.RepositorioDeBlogueiros;
import br.usp.ime.blog.repositorios.RepositorioException;

public class RepositorioDeBlogueirosJdbc extends BaseRepositorioJdbc implements
		RepositorioDeBlogueiros {

	public Blogueiro pegaBlogueiro(String login, String senha)
			throws RepositorioException {
		try {
			PreparedStatement stmt = preparaQuery("select * from blogueiro where login = ? and senha = ?");
			stmt.setString(1, login);
			stmt.setString(2, senha);
			ResultSet rs = stmt.executeQuery();

			if (rs.next()) {
				return popula(rs);
			}
			return null;
		} catch (SQLException ex) {
			throw new RepositorioException(ex);
		} finally {
			finaliza();
		}
	}

	private Blogueiro popula(ResultSet rs) throws SQLException {
		Blogueiro blogueiro = new Blogueiro();

		blogueiro.setLogin(rs.getString("login"));
		blogueiro.setNome(rs.getString("nome"));
		blogueiro.setEmail(rs.getString("email"));

		return blogueiro;
	}

	public void adicionaBlogueiro(Blogueiro blogueiro, String senha)
			throws RepositorioException {
		try {
			PreparedStatement stmt = preparaQuery("insert into blogueiro (nome, email, login, senha) values (?, ?, ?, ?)");
			stmt.setString(1, blogueiro.getNome());
			stmt.setString(2, blogueiro.getEmail());
			stmt.setString(3, blogueiro.getLogin());
			stmt.setString(4, senha);
			stmt.execute();
		} catch (SQLException ex) {
			throw new RepositorioException(ex);
		} finally {
			finaliza();
		}
	}
}
