package br.usp.ime.controller;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class FrontControllerServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;

	protected void service(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		String nomeDaClasse = descobreNomeDaClasse(request);
		ApplicationController acao = criaClasse(nomeDaClasse);
		executaAcao(request, response, acao);
	}

	private String descobreNomeDaClasse(HttpServletRequest request) {
		String[] uriQuebrado = request.getRequestURI().split("/");
		String nomeRequisitado = uriQuebrado[uriQuebrado.length - 1];

		String nomeDaAcao = nomeRequisitado.substring(0, nomeRequisitado
				.length() - 4);

		boolean ehAdmin = uriQuebrado[uriQuebrado.length - 2].equals("admin");
		String nomeDaClasse = "br.usp.ime.blog.actions."
				+ (ehAdmin ? "admin." : "") + nomeDaAcao + "AC";

		return nomeDaClasse;
	}

	private void executaAcao(HttpServletRequest request,
			HttpServletResponse response, ApplicationController acao)
			throws ServletException, IOException {

		try {
			acao.setRequest(request);
			acao.setResponse(response);

			String fwd = acao.executa();
			if(fwd.length()>0) {
				RequestDispatcher rd = request.getRequestDispatcher(fwd);
				rd.forward(request, response);
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw new ServletException(e);
		}
	}

	@SuppressWarnings("unchecked")
	private ApplicationController criaClasse(String nomeDaClasse)
			throws ServletException {
		Class clazz;
		try {
			clazz = Class.forName(nomeDaClasse);
			return (ApplicationController) clazz.newInstance();
		} catch (ClassNotFoundException ex) {
			throw new ServletException("Acao inexistente:" + nomeDaClasse);
		} catch (InstantiationException e) {
			throw new ServletException(e);
		} catch (IllegalAccessException e) {
			throw new ServletException(e);
		}
	}
}
